﻿-- Thomas Elliott
-- Version: 1.2
-- 8/17/2012

-- Creates Ace Object
PlayerFrameRemoval = LibStub("AceAddon-3.0"):NewAddon("PlayerFrameRemoval", "AceConsole-3.0")

-- Creates options menue for toggling visibility of player frame

local options = {
	name = "PlayerFrameRemoval",
	handler = PlayerFrameRemoval,
	type = 'group',
	args = {
		toggle = {
			type = "toggle",
			name = "Toggle Player Frame",
			desc = "Toggles player frame visibility.",
			get = "isVisible",
			set = "toggleShow",
		},	
		status = {
			type = "execute",
			name = "Player Frame Status",
			desc = "Displays visibility status on screen.",
			func = "status"
		},	
	},
}

-- Sets a default value for visibility when run for the first time on a profile
local defaults = {
	char = {
		visible = true,
	},
}

-- When the addon is loaded it creates a new AceDB if it doesn't already exist, registers the options table, and prints welcome message
function PlayerFrameRemoval:OnInitialize()
	
	self.db = LibStub("AceDB-3.0"):New("PFRDB", defaults, "Default")

	LibStub("AceConfig-3.0"):RegisterOptionsTable("PlayerFrameRemoval", options, {"playerframeremoval", "pfr"})
	
	self:Print("Thank you for using Player Frame Removal questions/comments/bugs feel free to email: tmelliottjr@yahoo.com \n toggle player frame visibility with /pfr toggle  OR  /playerframeremoval toggle")
	
	-- Tests whether or not the saved variable is true or false to determine visibility
	if self.db.char.visible then
		PlayerFrame:Show()
		PlayerFrame:SetScript("OnEvent", PlayerFrame_OnEvent);
	else 
		PlayerFrame:Hide()
		TargetFrame:SetScript("OnEvent", nil);
	end
end

-- Not sure I even need this?
function PlayerFrameRemoval:isVisible(info)
	return self.db.char.visible
end

-- When toggled checks whether frame is visible or not and changes visibility appropriately
function PlayerFrameRemoval:toggleShow(info, value)
	if self.db.char.visible then
		PlayerFrame:Hide()
		PlayerFrame:SetScript("OnEvent", nil);
		self.db.char.visible = false
		self:Print("Hidden")
		
		--[[ Saving this for future update
		TargetFrame:Hide()
		TargetFrame:SetScript("OnEvent", nil);
		]]
	else	
		PlayerFrame:Show()
		PlayerFrame:SetScript("OnEvent", PlayerFrame_OnEvent);
		self.db.char.visible = true
		self:Print("Visible")
		
		--[[ Saving this for future update
		-- TargetFrame:SetScript("OnEvent", TargetFrame_OnEvent);
		-- TargetFrame:Show()
		]] 
	end
end	

-- Checks status of visibility and displays it on the screen
function PlayerFrameRemoval:status(info)
	if self.db.char.visible then
		self:Print("Player frame is visible.")
	else
		self:Print("Player frame is hidden.")
	end
end
